#include <windows.h>
#include <commctrl.h>
#include "resource.h"
#include "dmusic.h"

#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"dxguid.lib")

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HWND	hCheck[9];			// `FbN{bNX̃nh
	static int	flag_BGM = 0;
	int			i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		if(!Music_Init()){						// DirectMusic
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(!LoadBGM_R(IDR_WAVE1,-5)){			// BGM̓ǂݍ
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(!LoadSND_F(0,"..\\eco00.wav",0)){	// ʉ̓ǂݍ
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(!LoadSND_EF_R(1,IDR_WAVE3,0)){		// ʉ̓ǂݍ
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		if(!LoadSND_EF_R(2,IDR_WAVE4,0)){		// ʉ̓ǂݍ
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		
		SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETTICFREQ,10,0);
		SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETRANGE,TRUE,MAKELONG(-40,40));
		SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_SETPOS,TRUE,0);

		hCheck[0] = GetDlgItem(hDlg,IDC_CHECK1);
		hCheck[1] = GetDlgItem(hDlg,IDC_CHECK2);
		hCheck[2] = GetDlgItem(hDlg,IDC_CHECK3);
		hCheck[3] = GetDlgItem(hDlg,IDC_CHECK4);
		hCheck[4] = GetDlgItem(hDlg,IDC_CHECK5);
		hCheck[5] = GetDlgItem(hDlg,IDC_CHECK6);
		hCheck[6] = GetDlgItem(hDlg,IDC_CHECK7);
		hCheck[7] = GetDlgItem(hDlg,IDC_CHECK8);
		hCheck[8] = GetDlgItem(hDlg,IDC_CHECK9);
		break;

	case WM_HSCROLL:
		long nVol;
		nVol = SendDlgItemMessage(hDlg,IDC_SLIDER1,TBM_GETPOS,0,0);
		if(!Set_Volume(nVol))				// {[̐ݒ
			SendMessage(hDlg,WM_CLOSE,0,0);
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_BUTTON1:
            if(!PlaySND(0))					// ʉP̍Đ
				SendMessage(hDlg,WM_CLOSE,0,0);
            break;

		case IDC_BUTTON2:
			for(i=0;i<9;i++){
				if(BST_CHECKED == SendMessage(hCheck[i],BM_GETCHECK,0,0))
					Flag_Effect[i] = 1;
				else
					Flag_Effect[i] = 0;
			}
            if(!PlaySND_EF(1))				// ʉQ̍Đ
				SendMessage(hDlg,WM_CLOSE,0,0);
            break;

		case IDC_BUTTON3:
			for(i=0;i<9;i++){
				if(BST_CHECKED == SendMessage(hCheck[i],BM_GETCHECK,0,0))
					Flag_Effect[i] = 1;
				else
					Flag_Effect[i] = 0;
			}
            if(!PlaySND_EF(2))				// ʉR̍Đ
				SendMessage(hDlg,WM_CLOSE,0,0);
            break;

		case IDC_BUTTON4:
			if(flag_BGM == 0){
				SetDlgItemText(hDlg,IDC_BUTTON4,"OFF");
				if(!PlayBGM())				// BGM̍Đ
					SendMessage(hDlg,WM_CLOSE,0,0);
				flag_BGM = 1;
			}
			else{
				SetDlgItemText(hDlg,IDC_BUTTON4,"ON");
				if(!StopBGM())				// BGM̒~
					SendMessage(hDlg,WM_CLOSE,0,0);
				flag_BGM = 0;
			}
            break;

		case IDOK:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;

		default:
			return FALSE;
		}
		break;

	case WM_CLOSE:
		DestroyWindow(hDlg);
		Music_Term();			// DirectMusic
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	HWND hDlg;
	
	InitCommonControls();
	
	hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(hDlg, nCmdShow);
	
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
